"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.PropertyAbility = void 0;
var _customAbility = _interopRequireDefault(require("custom-ability"));
var _utilEx = require("util-ex");
var _inheritsEx = require("inherits-ex");
var _abstract = _interopRequireDefault(require("./abstract.js"));
var _advance = _interopRequireDefault(require("./advance.js"));
var _normal = _interopRequireDefault(require("./normal.js"));
var _simple = _interopRequireDefault(require("./simple.js"));
var _index = _interopRequireDefault(require("./index.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/* eslint @typescript-eslint/no-invalid-this: 0 */

const getOwnPropertyNames = Object.getOwnPropertyNames;
const getOwnPropertyDescriptor = Object.getOwnPropertyDescriptor;
const defineProp = Object.defineProperty;
function extendCtor(target, source) {
  const names = getOwnPropertyNames(source).filter(n => !['length', 'name', 'arguments', 'caller', 'prototype'].includes(n));
  for (const n of names) {
    defineProp(target, n, getOwnPropertyDescriptor(source, n));
  }
}
function getPropertyManagerClass(aClass, aOptions) {
  if ((0, _utilEx.isString)(aOptions)) {
    aOptions = {
      name: aOptions
    };
  } else if ((0, _utilEx.isNumber)(aOptions)) {
    aOptions = {
      optionsPosition: aOptions
    };
  } else if (!aOptions) {
    aOptions = {};
  }
  const gOptPos = aOptions.optionsPosition || 0;
  // it could be null(Simple), ctor(complex attributes), object
  const gManager = String(aOptions.name);
  const nonExported1stChar = aOptions.nonExported1stChar || '$';
  function PropertyManager() {
    this.initialize(arguments[gOptPos]);
  }
  switch (gManager.toLowerCase()) {
    case 'simple':
      (0, _inheritsEx.extend)(PropertyManager, _simple.default);
      break;
    case 'advance':
      extendCtor(PropertyManager, _advance.default);
      (0, _inheritsEx.extend)(PropertyManager, _advance.default);
      break;
    case 'abstract':
      extendCtor(PropertyManager, _abstract.default);
      (0, _inheritsEx.extend)(PropertyManager, _abstract.default);
      break;
    case 'normal':
      extendCtor(PropertyManager, _normal.default);
      (0, _inheritsEx.extend)(PropertyManager, _normal.default);
      break;
    default:
      extendCtor(PropertyManager, _index.default);
      (0, _inheritsEx.extend)(PropertyManager, _index.default);
  }
  if ((0, _utilEx.isString)(nonExported1stChar) && nonExported1stChar.length === 1) {
    PropertyManager.prototype.nonExported1stChar = nonExported1stChar;
  }
  const orgInitialize = PropertyManager.prototype.initialize;

  // the non-enumerable property can not be replaced in an ability,
  // but beginning with '$' will be injected to `initialize` method.
  // replace the original initialize method.
  (0, _utilEx.defineProperty)(PropertyManager.prototype, '$initialize', function () {
    let options = arguments[gOptPos];
    if (options == null) {
      options = {};
    }
    const that = this.self || this;
    const inherited = this.super;
    if (inherited) {
      // call the parent's initialize method.
      if (inherited.apply(that, arguments) === 'ok') {
        return;
      }
    }
    // defineProperty that, 'defaultOptions', {}
    // that.defineProperties(options.attributes) if isFunction that.defineProperties
    // that.assign(options)
    return orgInitialize.call(that, options);
  });
  (0, _utilEx.defineProperty)(PropertyManager.prototype, '$assign', function () {
    const that = this.self || this;
    if (this.super) {
      return this.super.apply(that, arguments);
    }
    return this.__assign.apply(that, arguments);
  });
  return PropertyManager;
}
;
const coreMethods = ['__assign', 'assignPropertyTo', 'getProperties', 'mergeTo', 'defineProperties', 'nonExported1stChar'];
const PropertyAbility = (0, _customAbility.default)(getPropertyManagerClass, coreMethods, true);
exports.PropertyAbility = PropertyAbility;
var _default = PropertyAbility;
exports.default = _default;