"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AdvancePropertyManager = AdvancePropertyManager;
exports.default = void 0;
var _utilEx = require("util-ex");
var _inheritsEx = require("inherits-ex");
var _index = _interopRequireDefault(require("./properties/index.js"));
var _abstract = _interopRequireDefault(require("./abstract.js"));
var _defineProperties2 = _interopRequireDefault(require("./properties/define-properties"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function AdvancePropertyManager() {
  if (arguments.length) {
    this.initialize.apply(this, arguments);
  }
}

// merge the methods on the PropertyManager.prototype.
(0, _inheritsEx.extend)(AdvancePropertyManager, _abstract.default);
AdvancePropertyManager.getProperties = function getProperties() {
  const result = {};
  const attrs = this.prototype.$attributes;
  if (attrs) {
    for (const k in attrs) {
      const v = attrs[k];
      result[k] = v;
    }
  }
  return result;
};
AdvancePropertyManager.prototype.getProperties = function getProperties() {
  return this.$attributes;
};
AdvancePropertyManager.prototype.defineProperties = function defineProperties(aProperties, recreate = false) {
  const vAttrs = (0, _defineProperties2.default)(this, aProperties, recreate);
  vAttrs.initializeTo(this);
  return this;
};
AdvancePropertyManager.prototype.assignPropertyTo = function assignPropertyTo(dest, src, name, value, attrs, options) {
  if (!attrs) {
    attrs = this.getProperties();
  }
  attrs.assignPropertyTo(dest, src, name, value, options);
};
AdvancePropertyManager.prototype.$attributes = null;
AdvancePropertyManager.prototype.SMART_ASSIGN = _index.default.SMART_ASSIGN;
(0, _utilEx.defineProperty)(AdvancePropertyManager, '$attributes', undefined, {
  get() {
    return (0, _inheritsEx.getPrototypeOf)(this).$attributes;
  }
});
AdvancePropertyManager.defineProperties = _defineProperties2.default;
var _default = AdvancePropertyManager;
exports.default = _default;