"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assignValue = assignValue;
exports.default = void 0;
function assignValue(value, type) {
  if (typeof type === 'function' && !(value instanceof type)) {
    try {
      value = type(value);
    } catch (err) {
      const msg = err.message;
      if (!(msg.endsWith('\'new\'') || msg.endsWith(' a function'))) {
        throw err;
      }
      // eslint-disable-next-line new-cap
      value = new type(value);
    }
  }
  return value;
}
var _default = assignValue;
exports.default = _default;